import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ball extends Actor
{

    private int imageNumber;

    /**
     * Creates ball changes the initail rotation based on the variable direction
     */
    public Ball (int direction)
    {

        setRotation(direction); 
        imageNumber=0;
    }

    /**
     * Creates ball randndomly changes the initail position if the ball 
     */
    public Ball ()
    {
        int direction= Greenfoot.getRandomNumber(360);
        setRotation(direction);  
        imageNumber=0;
    }

    
    /**
     * Act - do whatever the Ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {

        
        moveBall();

        edgeTurn();

    }

    /**
     * Moves the ball
     */
    public void moveBall()
    {
        move(5);
    }

    /**
     * Changes the balls image
     */
    public void changeImage()
    {
        imageNumber++;
        if (imageNumber == 5)
        {
            imageNumber = 0;
        }

        setImage ("button-" + imageNumber + ".png");

    }   

    /**
     * Rotates the ball once it hits the worlds edge
     */
    public void edgeTurn()
    {
        if (atWorldEdge())
        {
            turn(Greenfoot.getRandomNumber(180));
            changeImage();
        }

    }

    /**
     * Check if the ball is at the world edge
     */ 
    public boolean atWorldEdge()
    {
        if(getX() < 10 || getX() > getWorld().getWidth()-10)
            return true;

        if (getY() < 10 || getY() > getWorld().getHeight() -10)
            return true;
        else
            return false;

    }

}
